ViewVC Help
View File | Revision Log | Show Annotations | Download File | Root Listing
root/radiance/ray/src/util/genBSDF.pl
(Generate patch)

Comparing ray/src/util/genBSDF.pl (file contents):
Revision 2.26 by greg, Tue Oct 25 20:51:10 2011 UTC vs.
Revision 2.37 by greg, Thu Jun 14 22:42:21 2012 UTC

# Line 8 | Line 8
8   use strict;
9   use File::Temp qw/ :mktemp  /;
10   sub userror {
11 <        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom] [input ..]\n";
11 >        print STDERR "Usage: genBSDF [-n Nproc][-c Nsamp][-t{3|4} Nlog2][-r \"ropts\"][-dim xmin xmax ymin ymax zmin zmax][{+|-}f][{+|-}b][{+|-}mgf][{+|-}geom units] [input ..]\n";
12          exit 1;
13   }
14   my $td = mkdtemp("/tmp/genBSDF.XXXXXX");
# Line 23 | Line 23 | my $geout = 1;
23   my $nproc = 1;
24   my $doforw = 0;
25   my $doback = 1;
26 + my $pctcull = 90;
27   my $gunit = "Meter";
28   my @dim;
29   # Get options
# Line 43 | Line 44 | while ($#ARGV >= 0) {
44                  $doforw = ("$ARGV[0]" =~ /^\+/);
45          } elsif ("$ARGV[0]" =~ /^[-+]b/) {
46                  $doback = ("$ARGV[0]" =~ /^\+/);
47 +        } elsif ("$ARGV[0]" eq "-t") {
48 +                # Use value < 0 for rttree_reduce bypass
49 +                $pctcull = $ARGV[1];
50 +                shift @ARGV;
51          } elsif ("$ARGV[0]" =~ /^-t[34]$/) {
52                  $tensortree = substr($ARGV[0], 2, 1);
53                  $ttlog2 = $ARGV[1];
# Line 66 | Line 71 | while ($#ARGV >= 0) {
71   }
72   # Check that we're actually being asked to do something
73   die "Must have at least one of +forward or +backward\n" if (!$doforw && !$doback);
69 # Name our own persist file?
70 my $persistfile;
71 if ( $tensortree && $nproc > 1 && "$rtargs" !~ /-PP /) {
72        $persistfile = "$td/pfile.txt";
73        $rtargs = "-PP $persistfile $rtargs";
74 }
74   # Get scene description and dimensions
75   my $radscn = "$td/device.rad";
76   my $mgfscn = "$td/device.mgf";
# Line 153 | Line 152 | exec("rm -rf $td");
152  
153   #-------------- End of main program segment --------------#
154  
156 #++++++++++++++ Kill persistent rtrace +++++++++++++++++++#
157 sub persist_end {
158        if ( $persistfile && open(PFI, "< $persistfile") ) {
159                while (<PFI>) {
160                        s/^[^ ]* //;
161                        kill('ALRM', $_);
162                        last;
163                }
164                close PFI;
165        }
166 }
167
155   #++++++++++++++ Tensor tree BSDF generation ++++++++++++++#
156   sub do_tree_bsdf {
170 # Get sampling rate and subdivide task
171 my $ns2 = $ns;
172 $ns2 /= 2 if ( $tensortree == 3 );
173 my $nsplice = $nproc;
174 $nsplice *= 10 if ($nproc > 1);
175 $nsplice = $ns2 if ($nsplice > $ns2);
176 $nsplice = 999 if ($nsplice > 999);
177 @pdiv = (0, int($ns2/$nsplice));
178 my $nrem = $ns2 % $nsplice;
179 for (my $i = 1; $i < $nsplice; $i++) {
180        my $nv = $pdiv[$i] + $pdiv[1];
181        ++$nv if ( $nrem-- > 0 );
182        push @pdiv, $nv;
183 }
184 die "Script error 1" if ($pdiv[-1] != $ns2);
157   # Shirley-Chiu mapping from unit square to disk
158   $sq2disk = '
159   in_square_a = 2*in_square_x - 1;
# Line 224 | Line 196 | out_square_y = (out_square_b + 1)/2;
196   print "\t<DataDefinition>\n";
197   print "\t\t<IncidentDataStructure>TensorTree$tensortree</IncidentDataStructure>\n";
198   print "\t</DataDefinition>\n";
199 < # Fork parallel rtcontrib processes to compute each side
200 < my $npleft = $nproc;
201 < if ( $doback ) {
202 <        for (my $splice = 0; $splice < $nsplice; $splice++) {
203 <                if (! $npleft ) {
232 <                        wait();
233 <                        die "rtcontrib process reported error" if ( $? );
234 <                        $npleft++;
235 <                }
236 <                bg_tree_rtcontrib(0, $splice);
237 <                $npleft--;
238 <        }
239 <        while (wait() >= 0) {
240 <                die "rtcontrib process reported error" if ( $? );
241 <                $npleft++;
242 <        }
243 <        persist_end();
244 <        ttree_out(0);
245 < }
246 < if ( $doforw ) {
247 <        for (my $splice = 0; $splice < $nsplice; $splice++) {
248 <                if (! $npleft ) {
249 <                        wait();
250 <                        die "rtcontrib process reported error" if ( $? );
251 <                        $npleft++;
252 <                }
253 <                bg_tree_rtcontrib(1, $splice);
254 <                $npleft--;
255 <        }
256 <        while (wait() >= 0) {
257 <                die "rtcontrib process reported error" if ( $? );
258 <                $npleft++;
259 <        }
260 <        persist_end();
261 <        ttree_out(1);
262 < }
199 >
200 > # Start rcontrib processes for compute each side
201 > do_tree_rtcontrib(0) if ( $doback );
202 > do_tree_rtcontrib(1) if ( $doforw );
203 >
204   }       # end of sub do_tree_bsdf()
205  
206 < # Run rtcontrib process in background to generate tensor tree samples
207 < sub bg_tree_rtcontrib {
267 <        my $pid = fork();
268 <        die "Cannot fork new process" unless defined $pid;
269 <        if ($pid > 0) { return $pid; }
206 > # Run rcontrib process in background to generate tensor tree samples
207 > sub do_tree_rtcontrib {
208          my $forw = shift;
271        my $pn = shift;
272        my $pbeg = $pdiv[$pn];
273        my $plen = $pdiv[$pn+1] - $pbeg;
209          my $matargs = "-m $bmodnm";
210          if ( !$forw || !$doback ) { $matargs .= " -m $fmodnm"; }
211 <        my $cmd = "rtcontrib $rtargs -h -ff -fo -c $nsamp " .
211 >        my $cmd = "rcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
212                  "-e '$disk2sq' -bn '$ns*$ns' " .
213                  "-b '$ns*floor(out_square_x*$ns)+floor(out_square_y*$ns)' " .
214 <                "-o $td/%s_" . sprintf("%03d", $pn) . ".flt $matargs $octree";
214 >                "-o $td/%s.flt $matargs $octree";
215          if ( $tensortree == 3 ) {
216                  # Isotropic BSDF
217 <                $cmd = "cnt $plen $ny $nx " .
218 <                        "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
219 <                        "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
220 <                        "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
221 <                        "-e 'Dx=1-2*($pbeg+\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
217 >                my $ns2 = $ns / 2;
218 >                $cmd = "cnt $ns2 $ny $nx " .
219 >                        "| rcalc -e 'r1=rand(.8681*recno-.673892)' " .
220 >                        "-e 'r2=rand(-5.37138*recno+67.1737811)' " .
221 >                        "-e 'r3=rand(+3.17603772*recno+83.766771)' " .
222 >                        "-e 'Dx=1-2*(\$1+r1)/$ns;Dy:0;Dz=sqrt(1-Dx*Dx)' " .
223                          "-e 'xp=(\$3+r2)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
224                          "-e 'yp=(\$2+r3)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
225                          "-e 'zp=$dim[5-$forw]' -e 'myDz=Dz*($forw*2-1)' " .
# Line 294 | Line 230 | sub bg_tree_rtcontrib {
230                  # Anisotropic BSDF
231                  # Sample area vertically to improve load balance, since
232                  # shading systems usually have bilateral symmetry (L-R)
233 <                $cmd = "cnt $plen $ns $ny $nx " .
234 <                        "| rcalc -e 'r1=rand(($pn+.8681)*recno-.673892)' " .
235 <                        "-e 'r2=rand(($pn-5.37138)*recno+67.1737811)' " .
236 <                        "-e 'r3=rand(($pn+3.17603772)*recno+83.766771)' " .
237 <                        "-e 'r4=rand(($pn-2.3857833)*recno-964.72738)' " .
238 <                        "-e 'in_square_x=($pbeg+\$1+r1)/$ns' " .
233 >                $cmd = "cnt $ns $ns $ny $nx " .
234 >                        "| rcalc -e 'r1=rand(.8681*recno-.673892)' " .
235 >                        "-e 'r2=rand(-5.37138*recno+67.1737811)' " .
236 >                        "-e 'r3=rand(3.17603772*recno+83.766771)' " .
237 >                        "-e 'r4=rand(-2.3857833*recno-964.72738)' " .
238 >                        "-e 'in_square_x=(\$1+r1)/$ns' " .
239                          "-e 'in_square_y=(\$2+r2)/$ns' -e '$sq2disk' " .
240                          "-e 'xp=(\$4+r3)*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
241                          "-e 'yp=(\$3+r4)*(($dim[3]-$dim[2])/$ny)+$dim[2]' " .
# Line 309 | Line 245 | sub bg_tree_rtcontrib {
245                          "| $cmd";
246          }
247   # print STDERR "Starting: $cmd\n";
248 <        exec($cmd);             # no return; status report to parent via wait
249 <        die "Cannot exec: $cmd\n";
250 < }       # end of bg_tree_rtcontrib()
248 >        system "$cmd" || die "Failure running rcontrib";
249 >        ttree_out($forw);
250 > }       # end of do_tree_rtcontrib()
251  
252   # Simplify and output tensor tree results
253   sub ttree_out {
254          my $forw = shift;
255          my $side = ("Back","Front")[$forw];
256 +        my $cmd;
257   # Only output one transmitted distribution, preferring backwards
258   if ( !$forw || !$doback ) {
259   print
# Line 331 | Line 268 | print
268                          <ScatteringDataType>BTDF</ScatteringDataType>
269                          <ScatteringData>
270   ';
271 < system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
272 <        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
273 <        "$td/" . ($bmodnm,$fmodnm)[$forw] . "_???.flt " .
274 <        "| rttree_reduce -h -ff -r $tensortree -g $ttlog2";
275 < die "Failure running rttree_reduce" if ( $? );
271 > $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
272 >        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
273 > if ($pctcull >= 0) {
274 >        $cmd .= "-of $td/" . ($bmodnm,$fmodnm)[$forw] . ".flt " .
275 >        "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
276 >        system "$cmd" || die "Failure running rttree_reduce";
277 > } else {
278 >        $cmd .= "$td/" . ($bmodnm,$fmodnm)[$forw] . ".flt";
279 >        print "{\n";
280 >        system "$cmd" || die "Failure running rcalc";
281 >        for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
282 >                print "0\n";
283 >        }
284 >        print "}\n";
285 > }
286   print
287   '                       </ScatteringData>
288                  </WavelengthDataBlock>
# Line 357 | Line 304 | print
304                          <ScatteringDataType>BRDF</ScatteringDataType>
305                          <ScatteringData>
306   ';
307 < system "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
308 <        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' -of } .
309 <        "$td/" . ($fmodnm,$bmodnm)[$forw] . "_???.flt " .
310 <        "| rttree_reduce -h -ff -r $tensortree -g $ttlog2";
311 < die "Failure running rttree_reduce" if ( $? );
307 > $cmd = "rcalc -if3 -e 'Omega:PI/($ns*$ns)' " .
308 >        q{-e '$1=(0.265*$1+0.670*$2+0.065*$3)/Omega' };
309 > if ($pctcull >= 0) {
310 >        $cmd .= "-of $td/" . ($fmodnm,$bmodnm)[$forw] . ".flt " .
311 >        "| rttree_reduce -a -h -ff -t $pctcull -r $tensortree -g $ttlog2";
312 >        system "$cmd" || die "Failure running rttree_reduce";
313 > } else {
314 >        $cmd .= "$td/" . ($fmodnm,$bmodnm)[$forw] . ".flt";
315 >        print "{\n";
316 >        system "$cmd" || die "Failure running rcalc";
317 >        for (my $i = ($tensortree==3)*$ns*$ns*$ns/2; $i-- > 0; ) {
318 >                print "0\n";
319 >        }
320 >        print "}\n";
321 > }
322   print
323   '                       </ScatteringData>
324                  </WavelengthDataBlock>
# Line 378 | Line 335 | sub do_matrix_bsdf {
335   $tcal = '
336   DEGREE : PI/180;
337   sq(x) : x*x;
338 < Kpola(r) : select(r+1, -5, 5, 15, 25, 35, 45, 55, 65, 75, 90);
338 > Kpola(r) : select(r+1, 0, 5, 15, 25, 35, 45, 55, 65, 75, 90);
339   Knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
340   Kaccum(r) : if(r-.5, Knaz(r) + Kaccum(r-1), 0);
341   Kmax : Kaccum(Knaz(0));
# Line 399 | Line 356 | KprojOmega = PI * if(Kbin-.5,
356   $kcal = '
357   DEGREE : PI/180;
358   abs(x) : if(x, x, -x);
359 < Acos(x) : 1/DEGREE * if(x-1, 0, if(-1-x, 0, acos(x)));
359 > Acos(x) : if(x-1, 0, if(-1-x, PI, acos(x))) / DEGREE;
360   posangle(a) : if(-a, a + 2*PI, a);
361 < Atan2(y,x) : 1/DEGREE * posangle(atan2(y,x));
361 > Atan2(y,x) : posangle(atan2(y,x)) / DEGREE;
362   kpola(r) : select(r, 5, 15, 25, 35, 45, 55, 65, 75, 90);
363   knaz(r) : select(r, 1, 8, 16, 20, 24, 24, 24, 16, 12);
364   kaccum(r) : if(r-.5, knaz(r) + kaccum(r-1), 0);
# Line 422 | Line 379 | kbin2(pol,azi) = select(kfindrow(1, pol),
379   kbin = kbin2(Acos(abs(Dz)),Atan2(Dy,Dx));
380   ';
381   my $ndiv = 145;
382 < # Compute scattering data using rtcontrib
382 > # Compute scattering data using rcontrib
383   my @tfarr;
384   my @rfarr;
385   my @tbarr;
386   my @rbarr;
387   my $cmd;
388 < my $rtcmd = "rtcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
388 > my $rtcmd = "rcontrib $rtargs -h -ff -fo -n $nproc -c $nsamp " .
389          "-e '$kcal' -b kbin -bn $ndiv " .
390          "-o '$td/%s.flt' -m $fmodnm -m $bmodnm $octree";
391   my $rccmd = "rcalc -e '$tcal' " .
392          "-e 'mod(n,d):n-floor(n/d)*d' -e 'Kbin=mod(recno-.999,$ndiv)' " .
393 <        q{-if3 -e 'oval=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' } .
437 <        q[-o '${  oval  },'];
393 >        q{-if3 -e '$1=(0.265*$1+0.670*$2+0.065*$3)/KprojOmega' };
394   if ( $doforw ) {
395   $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
396          "-e 'xp=(\$3+rand(.12*recno+288))*(($dim[1]-$dim[0])/$nx)+$dim[0]' " .
# Line 460 | Line 416 | $cmd = "cnt $ndiv $ny $nx | rcalc -of -e '$tcal' " .
416   system "$cmd" || die "Failure running: $cmd\n";
417   @tbarr = `$rccmd $td/$bmodnm.flt`;
418   die "Failure running: $rccmd $td/$bmodnm.flt\n" if ( $? );
419 + chomp(@tbarr);
420   @rbarr = `$rccmd $td/$fmodnm.flt`;
421   die "Failure running: $rccmd $td/$fmodnm.flt\n" if ( $? );
422 + chomp(@rbarr);
423   }
424   # Output angle basis
425   print
# Line 470 | Line 428 | print
428                  <AngleBasis>
429                          <AngleBasisName>LBNL/Klems Full</AngleBasisName>
430                          <AngleBasisBlock>
431 <                                <Theta>0</Theta>
432 <                                <nPhis>1</nPhis>
433 <                                <ThetaBounds>
434 <                                        <LowerTheta>0</LowerTheta>
435 <                                        <UpperTheta>5</UpperTheta>
436 <                                </ThetaBounds>
479 <                                </AngleBasisBlock>
480 <                                <AngleBasisBlock>
481 <                                <Theta>10</Theta>
482 <                                <nPhis>8</nPhis>
483 <                                <ThetaBounds>
484 <                                        <LowerTheta>5</LowerTheta>
485 <                                        <UpperTheta>15</UpperTheta>
486 <                                </ThetaBounds>
487 <                                </AngleBasisBlock>
488 <                                <AngleBasisBlock>
489 <                                <Theta>20</Theta>
490 <                                <nPhis>16</nPhis>
491 <                                <ThetaBounds>
492 <                                        <LowerTheta>15</LowerTheta>
493 <                                        <UpperTheta>25</UpperTheta>
494 <                                </ThetaBounds>
495 <                                </AngleBasisBlock>
496 <                                <AngleBasisBlock>
497 <                                <Theta>30</Theta>
498 <                                <nPhis>20</nPhis>
499 <                                <ThetaBounds>
500 <                                        <LowerTheta>25</LowerTheta>
501 <                                        <UpperTheta>35</UpperTheta>
502 <                                </ThetaBounds>
503 <                                </AngleBasisBlock>
504 <                                <AngleBasisBlock>
505 <                                <Theta>40</Theta>
506 <                                <nPhis>24</nPhis>
507 <                                <ThetaBounds>
508 <                                        <LowerTheta>35</LowerTheta>
509 <                                        <UpperTheta>45</UpperTheta>
510 <                                </ThetaBounds>
511 <                                </AngleBasisBlock>
512 <                                <AngleBasisBlock>
513 <                                <Theta>50</Theta>
514 <                                <nPhis>24</nPhis>
515 <                                <ThetaBounds>
516 <                                        <LowerTheta>45</LowerTheta>
517 <                                        <UpperTheta>55</UpperTheta>
518 <                                </ThetaBounds>
519 <                                </AngleBasisBlock>
520 <                                <AngleBasisBlock>
521 <                                <Theta>60</Theta>
522 <                                <nPhis>24</nPhis>
523 <                                <ThetaBounds>
524 <                                        <LowerTheta>55</LowerTheta>
525 <                                        <UpperTheta>65</UpperTheta>
526 <                                </ThetaBounds>
527 <                                </AngleBasisBlock>
528 <                                <AngleBasisBlock>
529 <                                <Theta>70</Theta>
530 <                                <nPhis>16</nPhis>
531 <                                <ThetaBounds>
532 <                                        <LowerTheta>65</LowerTheta>
533 <                                        <UpperTheta>75</UpperTheta>
534 <                                </ThetaBounds>
535 <                                </AngleBasisBlock>
536 <                                <AngleBasisBlock>
537 <                                <Theta>82.5</Theta>
538 <                                <nPhis>12</nPhis>
539 <                                <ThetaBounds>
540 <                                        <LowerTheta>75</LowerTheta>
541 <                                        <UpperTheta>90</UpperTheta>
542 <                                </ThetaBounds>
431 >                        <Theta>0</Theta>
432 >                        <nPhis>1</nPhis>
433 >                        <ThetaBounds>
434 >                                <LowerTheta>0</LowerTheta>
435 >                                <UpperTheta>5</UpperTheta>
436 >                        </ThetaBounds>
437                          </AngleBasisBlock>
438 +                        <AngleBasisBlock>
439 +                        <Theta>10</Theta>
440 +                        <nPhis>8</nPhis>
441 +                        <ThetaBounds>
442 +                                <LowerTheta>5</LowerTheta>
443 +                                <UpperTheta>15</UpperTheta>
444 +                        </ThetaBounds>
445 +                        </AngleBasisBlock>
446 +                        <AngleBasisBlock>
447 +                        <Theta>20</Theta>
448 +                        <nPhis>16</nPhis>
449 +                        <ThetaBounds>
450 +                                <LowerTheta>15</LowerTheta>
451 +                                <UpperTheta>25</UpperTheta>
452 +                        </ThetaBounds>
453 +                        </AngleBasisBlock>
454 +                        <AngleBasisBlock>
455 +                        <Theta>30</Theta>
456 +                        <nPhis>20</nPhis>
457 +                        <ThetaBounds>
458 +                                <LowerTheta>25</LowerTheta>
459 +                                <UpperTheta>35</UpperTheta>
460 +                        </ThetaBounds>
461 +                        </AngleBasisBlock>
462 +                        <AngleBasisBlock>
463 +                        <Theta>40</Theta>
464 +                        <nPhis>24</nPhis>
465 +                        <ThetaBounds>
466 +                                <LowerTheta>35</LowerTheta>
467 +                                <UpperTheta>45</UpperTheta>
468 +                        </ThetaBounds>
469 +                        </AngleBasisBlock>
470 +                        <AngleBasisBlock>
471 +                        <Theta>50</Theta>
472 +                        <nPhis>24</nPhis>
473 +                        <ThetaBounds>
474 +                                <LowerTheta>45</LowerTheta>
475 +                                <UpperTheta>55</UpperTheta>
476 +                        </ThetaBounds>
477 +                        </AngleBasisBlock>
478 +                        <AngleBasisBlock>
479 +                        <Theta>60</Theta>
480 +                        <nPhis>24</nPhis>
481 +                        <ThetaBounds>
482 +                                <LowerTheta>55</LowerTheta>
483 +                                <UpperTheta>65</UpperTheta>
484 +                        </ThetaBounds>
485 +                        </AngleBasisBlock>
486 +                        <AngleBasisBlock>
487 +                        <Theta>70</Theta>
488 +                        <nPhis>16</nPhis>
489 +                        <ThetaBounds>
490 +                                <LowerTheta>65</LowerTheta>
491 +                                <UpperTheta>75</UpperTheta>
492 +                        </ThetaBounds>
493 +                        </AngleBasisBlock>
494 +                        <AngleBasisBlock>
495 +                        <Theta>82.5</Theta>
496 +                        <nPhis>12</nPhis>
497 +                        <ThetaBounds>
498 +                                <LowerTheta>75</LowerTheta>
499 +                                <UpperTheta>90</UpperTheta>
500 +                        </ThetaBounds>
501 +                        </AngleBasisBlock>
502                  </AngleBasis>
503          </DataDefinition>
504   ';
# Line 561 | Line 519 | print
519   # Output front transmission (transposed order)
520   for (my $od = 0; $od < $ndiv; $od++) {
521          for (my $id = 0; $id < $ndiv; $id++) {
522 <                print $tfarr[$ndiv*$id + $od];
522 >                print $tfarr[$ndiv*$id + $od], ",\n";
523          }
524          print "\n";
525   }
# Line 584 | Line 542 | print
542   # Output front reflection (transposed order)
543   for (my $od = 0; $od < $ndiv; $od++) {
544          for (my $id = 0; $id < $ndiv; $id++) {
545 <                print $rfarr[$ndiv*$id + $od];
545 >                print $rfarr[$ndiv*$id + $od], ",\n";
546          }
547          print "\n";
548   }
# Line 611 | Line 569 | print
569   # Output back transmission (transposed order)
570   for (my $od = 0; $od < $ndiv; $od++) {
571          for (my $id = 0; $id < $ndiv; $id++) {
572 <                print $tbarr[$ndiv*$id + $od];
572 >                print $tbarr[$ndiv*$id + $od], ",\n";
573          }
574          print "\n";
575   }
# Line 634 | Line 592 | print
592   # Output back reflection (transposed order)
593   for (my $od = 0; $od < $ndiv; $od++) {
594          for (my $id = 0; $id < $ndiv; $id++) {
595 <                print $rbarr[$ndiv*$id + $od];
595 >                print $rbarr[$ndiv*$id + $od], ",\n";
596          }
597          print "\n";
598   }

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines